clear
clc
format long 
xx=xlsread('excel deta.xlsx','B2:B100');
yy=xlsread('excel deta.xlsx','C2:C100');
zz=xlsread('excel deta.xlsx','D2:D100');
E=xlsread('excel deta.xlsx','L2:L100');
G=xlsread('excel deta.xlsx','N2:N100');
J=xlsread('excel deta.xlsx','M2:M100');
Iy=xlsread('excel deta.xlsx','I2:I100');
Iz=xlsread('excel deta.xlsx','J2:J100');
A=xlsread('excel deta.xlsx','K2:K100');
force=xlsread('excel deta.xlsx','O2:O100');
N=xlsread('excel deta.xlsx','A2:A100');
M=xlsread('excel deta.xlsx','F2:F100');
elementNodes1=xlsread('excel deta.xlsx','G2:G100');
elementNodes2=xlsread('excel deta.xlsx','H2:H100');
fixconnection=xlsread('excel deta.xlsx','E2:E100');
fixconnection=nnz(fixconnection);
fixconnection=fixconnection*6;
nodeCoordinates=[xx yy zz];
elementNodes=[elementNodes1 elementNodes2];
numberNodes=size(N,1);
numberElements=size(M,1);
GDof=6*numberNodes;
stiffness=zeros(GDof);
for i=1:numberElements;
indice=elementNodes(i,:) ;
elementDof=[6*indice(1)-5 6*indice(1)-4 6*indice(1)-3 ...
6*indice(1)-2 6*indice(1)-1 6*indice(1)...
6*indice(2)-5 6*indice(2)-4 6*indice(2)-3 ...
6*indice(2)-2 6*indice(2)-1 6*indice(2)] ;
x1=nodeCoordinates(indice(1),1);
y1=nodeCoordinates(indice(1),2);
z1=nodeCoordinates(indice(1),3);
x2=nodeCoordinates(indice(2),1);
y2=nodeCoordinates(indice(2),2);
z2=nodeCoordinates(indice(2),3);
L = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) +...
(z2-z1)*(z2-z1));
k1=E(i)*A(i)/L;
k2 = 12*E(i)*Iz(i)/(L*L*L);
k3 = 6*E(i)*Iz(i)/(L*L);
k4 = 4*E(i)*Iz(i)/L;
k5 = 2*E(i)*Iz(i)/L;
k6 = 12*E(i)*Iy(i)/(L*L*L);
k7 = 6*E(i)*Iy(i)/(L*L);
k8 = 4*E(i)*Iy(i)/L;
k9 = 2*E(i)*Iy(i)/L;
k10 = G(i)*J(i)/L;
a=[k1 0 0; 0 k2 0; 0 0 k6];
b=[ 0 0 0;0 0 k3; 0 -k7 0];
c=[k10 0 0;0 k8 0; 0 0 k4];
d=[-k10 0 0;0 k9 0;0 0 k5];
k = [a b -a b;b' c b d; (-a)' b' a -b;b' d' (-b)' c];
if x1 == x2 && y1 == y2
if z2 > z1
Lambda = [0 0 1 ; 0 1 0 ; -1 0 0];
else
Lambda = [0 0 -1 ; 0 1 0 ; 1 0 0];
end
else%koliye mavarede zir cosinus haye hadi %
CXx = (x2-x1)/L;
CYx = (y2-y1)/L;
CZx = (z2-z1)/L;
D = sqrt(CXx*CXx + CYx*CYx);
CXy = -CYx/D;
CYy = CXx/D;
CZy = 0;
CXz = -CXx*CZx/D;
CYz = -CYx*CZx/D;
CZz = D;
Lambda = [CXx CYx CZx ;CXy CYy CZy ;CXz CYz CZz];
end
R = [Lambda zeros(3,9); zeros(3) Lambda zeros(3,6);
zeros(3,6) Lambda zeros(3);zeros(3,9) Lambda];
stiffness(elementDof,elementDof)=...
stiffness(elementDof,elementDof)+R'*k*R;
K=stiffness;
end
f=force;
n=fixconnection;
K1=K;
for s=1:n
    K1(s,:)=[];
    K1(:,s)=[];
end
U=f'/K1;
U=U';
U%%%%%%%%%%%displace of node%
K1%%%%%%%%%%%%assembled matrix%
K%%%%%%%%%%%%full stiffness matrix%







